/*****************************************************************************/
/*                      WiNRADiO G65DDC EXCALIBUR SIGMA                      */
/*                          Coherent mode SDK DEMO                           */
/*           Device set selection and "No device set found" dialogs          */
/*                        (c) Copyright RADIXON 2023                         */
/*****************************************************************************/

#ifndef __U_RECEIVERSELECTOR_H__
#define __U_RECEIVERSELECTOR_H__

#include <wx/wx.h>
#include "g65ddcapi.h"

//TDeviceSetSelector window appears when more than one device sets are detected
//the user can select one of them
class TDeviceSetSelector:public wxDialog
{
public:
    static ICohG65DDCDeviceSet* SelectDeviceSet(void);

    inline int GetSelectedDeviceSetIndex(void) const
    {
        return m_DeviceSetIndex;
    }

    TDeviceSetSelector(ICohG65DDCDeviceSetEnumerator *Enumerator);
    ~TDeviceSetSelector(void);
private:
    wxRadioBox      *m_RadioBox;
    wxButton        *m_BOK;
    wxButton        *m_BCancel;
    int             m_DeviceSetIndex;

    void OnOk(wxCommandEvent &Event);

    DECLARE_EVENT_TABLE()
};

//TNoDeviceSetFoundWindow window appears when no device set is detected
class TNoDeviceSetFoundWindow:public wxDialog
{
public:
    TNoDeviceSetFoundWindow(void);
    ~TNoDeviceSetFoundWindow(void);
private:
    wxButton    *m_BTryAgain;
    wxButton    *m_BDemo;
    wxButton    *m_BCancel;

    void OnTryAgain(wxCommandEvent &Event);
    void OnDemo(wxCommandEvent &Event);

    DECLARE_EVENT_TABLE()
};

#endif
