/*****************************************************************************/
/*                      WiNRADiO G65DDC EXCALIBUR SIGMA                      */
/*                          Coherent mode SDK DEMO                           */
/*                        (c) Copyright RADIXON 2023                         */
/*****************************************************************************/

#ifndef __U_PHASE_H__
#define __U_PHASE_H__

#include <wx/wx.h>
#include <stdint.h>

typedef int32_t int32_pair[2];
typedef float float_pair[2];

class TPhase:public wxPanel
{
public:
    void Clear(void);
    void Add(float From,float To);

    inline int GetRange(void) const
    {
        return m_Range;
    }

    void SetRange(int Range);

    virtual bool Enable(bool enable);

    TPhase(wxWindow *Parent,wxWindowID id,const wxPoint &Position=wxDefaultPosition,const wxSize &Size=wxDefaultSize);
    ~TPhase(void);
protected:
private:
    wxMutex             m_Mutex;
    int32_pair          *m_YData;
    int                 *m_YData_AVG;
    int                 m_Width;
    int                 m_Height;
    int                 m_Range;
    wxRect              m_GraphRect;
    int                 m_Count;
    int                 m_StartPos;
    float               m_AVG;
    float               m_AVG_From;
    float               m_AVG_To;
    bool                m_DataChanged;

    void OnPaintEvent(wxPaintEvent &Event);
    void OnSizeEvent(wxSizeEvent &Event);
    void OnEraseBackgroundEvent(wxEraseEvent &Event);
    void OnDataChanged(wxNotifyEvent &Event);

    void UpdateParams(void);

    DECLARE_EVENT_TABLE()
};

#endif
