/*****************************************************************************/
/*                      WiNRADiO G65DDC EXCALIBUR SIGMA                      */
/*                       Coherent mode SDK DEMO - ETC                        */
/*                     Simple edit box for frequencies                       */
/*                        (c) Copyright RADIXON 2023                         */
/*****************************************************************************/

#ifndef __U_FREQUENCYEDIT_H__
#define __U_FREQUENCYEDIT_H__

#include "u_numericedit.h"

typedef enum
{
    FrequencyEditUnits_Hz=0,
    FrequencyEditUnits_kHz,
    FrequencyEditUnits_MHz,
    FrequencyEditUnits_GHz,
} TFrequencyEditUnits;

class TFrequencyEdit:public TNumericEdit
{
public:
    inline bool GetAutoUnits(void) const
    {
        return m_AutoUnits;
    }
    inline void SetAutoUnits(bool Value)
    {
        m_AutoUnits=Value;
    }

    inline TFrequencyEditUnits GetUnits(void) const
    {
        return m_Units;
    }

    inline void SetUnits(TFrequencyEditUnits Units)
    {
        if(m_Units!=Units)
        {
            m_Units=Units;
            UpdateText();
        }
    }

    TFrequencyEdit(wxWindow *Parent,wxWindowID Id,int64_t Value,int64_t MinValue,int64_t MaxValue,const wxPoint &Position=wxDefaultPosition,const wxSize &Size=wxDefaultSize);
    ~TFrequencyEdit(void);
protected:
    virtual bool Parse(const wxString &Str,int64_t *Value);
    virtual wxString Format(int64_t Value);
private:
    TFrequencyEditUnits m_Units;
    bool                m_AutoUnits;
};

#endif
