#ifndef __G65DDC_EXAMPLE_H__
#define __G65DDC_EXAMPLE_H__

#include "g65ddcapi.h"
#include <pulse/simple.h>

class TG65DDC:public IG65DDCDeviceCallback
{
public:
    bool LoadAPI(void);
    void UnloadAPI(void);

    bool Open(const char *DevicePath);

    inline bool OpenFirst(void)
    {
        //open the first available G65DDC receiver
        return Open(G65DDC_OPEN_FIRST);
    }

    inline bool OpenDemo(void)
    {
        //open demo G65DDC receiver
        return Open(G65DDC_OPEN_DEMO);
    }

    void Close(void);

    void StartStreaming(void);
    void StopStreaming(void);


    void OpenWaveOut(void);
    void CloseWaveOut(void);

    //methods of IG65DDCDeviceCallback callback interface
    void G65DDC_DDC1StreamCallback(IG65DDCDevice *Device,uint32_t DDC1ChannelId,const void *Buffer,uint32_t Count,uint32_t BitsPerSample);
    int G65DDC_DDC1PlaybackStreamCallback(IG65DDCDevice *Device,uint32_t DDC1ChannelId,void *Buffer,uint32_t Count,uint32_t BitsPerSample);
    void G65DDC_DDC2StreamCallback(IG65DDCDevice *Device,uint32_t DDC2ChannelId,const float *Buffer,uint32_t Count);
    void G65DDC_DDC2PreprocessedStreamCallback(IG65DDCDevice *Device,uint32_t DDC2ChannelId,const float *Buffer,uint32_t Count,float SlevelPeak,float SlevelRMS);
    void G65DDC_ADCSnapshotCallback(IG65DDCDevice *Device,const int16_t *Buffer,uint32_t Count,uint32_t CenterFrequency,uint16_t ADCLevel);
    void G65DDC_AudioStreamCallback(IG65DDCDevice *Device,uint32_t DDC2ChannelId,uint32_t Stage,const float *Buffer,uint32_t Count);
    int G65DDC_AudioPlaybackStreamCallback(IG65DDCDevice *Device,uint32_t DDC2ChannelId,float *Buffer,uint32_t Count);

    TG65DDC(void);
    ~TG65DDC(void);
private:
    IG65DDCDevice               *m_Device;
    void                        *m_API;
    G65DDC_CREATE_INSTANCE      m_CreateInstance;
    pa_simple                   *m_PaSimple;
    uint32_t                    m_DDC1Id;
    uint32_t                    m_DDC2Id;
};

#endif
